import { createServer } from 'http';
//import { parse } from 'url';
import url from 'node:url';
import { WebSocketServer } from 'ws';

//-------------------- Configuración ---------------------------------

const host = 'localhost';
const port = 8080;

const connectionData = {
          event: "Connection data"
    }    ;

const periodicData = {
          event: "Periodic data"
    }    ;

const queryData = {
          event: "Query data"
    }    ;

// ------------------- Listener HTTP -------------------------------
const requestListener = function (request, res)
{
   const myURL = new URL(request.url, `http://${request.headers.host}`);
   const {pathname} = myURL;


   if (pathname === '/query')
   {
     res.writeHead(200, { 'Content-Type': 'application/json' });
     res.end(JSON.stringify(queryData));
   }
   else
   {
      res.writeHead(404, { 'Content-Type': 'application/json' });
      res.end("[]");
   }

};


//-------------------- Create Servers --------------------------------

const server = createServer(requestListener);
const wss = new WebSocketServer({ noServer: true });

// -------------- WebSocket Server -----------------------------------

wss.on('connection', function connection(ws,request) {
    console.log('Connetion: %s', request.url);


  ws.on('message', function message(data) {
    console.log('received: %s', data);
  });

  ws.send(JSON.stringify(connectionData));

  setInterval(async () => {

    ws.send(JSON.stringify(periodicData));
  }, 1000);

  ws.on('close', function close() {
     console.log('WS disconnected');
   });
  ws.on('error', function err() {
     console.log('WS error');
   });

 });

//--------- Conexión HTTP Server y  WebSocketServer ----------------
server.on('upgrade', function upgrade(request, socket, head)
{
   const myURL = new URL(request.url, `ws://${request.headers.host}`);
   const {pathname} = myURL;

   if (pathname === '/ws') {
   console.log('upgrade: %s', request.url);
          wss.handleUpgrade(request, socket, head, function done(ws) {
          wss.emit('connection', ws, request);
    });
  }
  else {
    socket.destroy();
  }
});


// ----------- HTTP server UP ----------------------

server.listen(port,host,() => {
    console.log(`Server is running on http://${host}:${port}`);
});
